'''Records speech and detects wakewords in real time.'''

from preprocessing import *
from model import *
import pyaudio
import winsound 
import time

fs = 48000
framesize = 12000

p = pyaudio.PyAudio()
stream = p.open(format=pyaudio.paInt16, channels=1, rate=fs, input=True, frames_per_buffer=framesize)

def record():
    data = stream.read(framesize)
    raw_speech = np.fromstring(data, dtype=np.int16)
    return normalize(get_mfcc(raw_speech, fs), mean, std)

with tf.Session() as sess:
    saver.restore(sess, "./models/" + model_name + ".ckpt")
    st = np.zeros((1, n_neurons))
    count = 0
    print("Recording...")
    while True:
        coeff = record()
        st, wp = sess.run([states, wakeword_probs], feed_dict={X: [coeff], initial_state: st})
        if True in (wp > threshold):
            count+=1
            print("Wake word detected #", count)
            st = np.zeros((1, n_neurons))
    stream.stop_stream()
    stream.close()
    p.terminate()