'''Records speech and detects wakewords in real time.'''

from preprocessing import *
from model import *
import pyaudio
import time
import threading

fs = 48000
framesize = 72000
count = 0

def detect_wakewords():
    global sess
    global count

    # Recursively call function every 0.25 seconds
    threading.Timer(0.25, detect_wakewords).start()
    p = pyaudio.PyAudio()
    stream = p.open(format=pyaudio.paInt16, channels=1, rate=fs, input=True, frames_per_buffer=framesize)
    data = stream.read(framesize)
    raw_speech = np.fromstring(data, dtype=np.int16)
    coeff =  normalize(get_mfcc(raw_speech, fs), mean, std)
    wp = sess.run([wakeword_prob], feed_dict={X: [coeff]})
    
    if (wp[0] > threshold):
        count+=1
        print("Wake word detected #", count)
    
    stream.stop_stream()
    stream.close()
    p.terminate()

sess = tf.Session()
saver.restore(sess, "./models/" + model_name + ".ckpt")
print("Recording...")

detect_wakewords()

# Keep session open
while True:
    time.sleep(10)